#ifndef _DECL_CkCache_H_
#define _DECL_CkCache_H_
#include "charm++.h"
/* DECLS: message CkCacheRequestMsg;
 */
class CkCacheRequestMsg;
class CMessage_CkCacheRequestMsg:public CkMessage{
  public:
    static int __idx;
    void* operator new(size_t, void*p) { return p; }
    void* operator new(size_t);
    void* operator new(size_t, int*, const int);
    void* operator new(size_t, int*);
#if CMK_MULTIPLE_DELETE
    void operator delete(void*p, void*){dealloc(p);}
    void operator delete(void*p){dealloc(p);}
    void operator delete(void*p, int*, const int){dealloc(p);}
    void operator delete(void*p, int*){dealloc(p);}
#endif
    void operator delete(void*p, size_t){dealloc(p);}
    static void* alloc(int,size_t, int*, int);
    static void dealloc(void *p);
    CMessage_CkCacheRequestMsg() {};
    static void *pack(CkCacheRequestMsg *p);
    static CkCacheRequestMsg* unpack(void* p);
    void *operator new(size_t, const int);
#if CMK_MULTIPLE_DELETE
    void operator delete(void *p, const int){dealloc(p);}
#endif
    static void __register(const char *s, size_t size, CkPackFnPtr pack, CkUnpackFnPtr unpack) {
      __idx = CkRegisterMsg(s, pack, unpack, dealloc, size);
    }
};

/* DECLS: message CkCacheFillMsg{
char data[];
}
;
 */
class CkCacheFillMsg;
class CMessage_CkCacheFillMsg:public CkMessage{
  public:
    static int __idx;
    void* operator new(size_t, void*p) { return p; }
    void* operator new(size_t);
    void* operator new(size_t, int*, const int);
    void* operator new(size_t, int*);
#if CMK_MULTIPLE_DELETE
    void operator delete(void*p, void*){dealloc(p);}
    void operator delete(void*p){dealloc(p);}
    void operator delete(void*p, int*, const int){dealloc(p);}
    void operator delete(void*p, int*){dealloc(p);}
#endif
    void operator delete(void*p, size_t){dealloc(p);}
    static void* alloc(int,size_t, int*, int);
    static void dealloc(void *p);
    CMessage_CkCacheFillMsg() {};
    static void *pack(CkCacheFillMsg *p);
    static CkCacheFillMsg* unpack(void* p);
    void *operator new(size_t, int);
    void *operator new(size_t, int, const int);
#if CMK_MULTIPLE_DELETE
    void operator delete(void *p, int){dealloc(p);}
    void operator delete(void *p, int, const int){dealloc(p);}
#endif
    static void __register(const char *s, size_t size, CkPackFnPtr pack, CkUnpackFnPtr unpack) {
      __idx = CkRegisterMsg(s, pack, unpack, dealloc, size);
    }
};

/* DECLS: group CkCacheManager: IrrGroup{
CkCacheManager(CkMigrateMessage* impl_msg);
CkCacheManager(int size, const CkGroupID &gid);
CkCacheManager(int size, int n, const CkGroupID *gid);
CkCacheManager(int size, int n, const CkGroupID *gid, int nWB, const CkGroupID *gidWB);
void* requestData(const CkCacheKey &what, const CkArrayIndexMax &toWhom, int chunk, CkCacheEntryType* impl_msg, const CkCacheRequestorData &req);
void* requestDataNoFetch(const CkCacheKey &key, int chunk);
void cacheSync(const int &numChunks, const CkArrayIndexMax &chareIdx, const int &localIdx);
void recvData(CkCacheFillMsg* impl_msg);
void recvData(const CkCacheKey &key, const CkArrayIndexMax &from, CkCacheEntryType* impl_msg, int chunk, void* data);
void writebackChunk(int num);
void finishedChunk(int num, const CmiUInt8 &weight);
void collectStatistics(const CkCallback &cb);
std::map<CkCacheKey,CkCacheEntry* >* getCache(void);
CkCacheEntry* requestCacheEntryNoFetch(const CkCacheKey &key, int chunk);
};
 */
 class CkCacheManager;
 class CkIndex_CkCacheManager;
 class CProxy_CkCacheManager;
 class CProxyElement_CkCacheManager;
 class CProxySection_CkCacheManager;
/* --------------- index object ------------------ */
class CkIndex_CkCacheManager:public CProxyElement_IrrGroup{
  public:
    typedef CkCacheManager local_t;
    typedef CkIndex_CkCacheManager index_t;
    typedef CProxy_CkCacheManager proxy_t;
    typedef CProxyElement_CkCacheManager element_t;
    typedef CProxySection_CkCacheManager section_t;

    static int __idx;
    static void __register(const char *s, size_t size);
/* DECLS: CkCacheManager(CkMigrateMessage* impl_msg);
 */
    static int __idx_CkCacheManager_CkMigrateMessage;
    static int ckNew(CkMigrateMessage* impl_msg) { return __idx_CkCacheManager_CkMigrateMessage; }
    static void _call_CkCacheManager_CkMigrateMessage(void* impl_msg,CkCacheManager* impl_obj);

/* DECLS: CkCacheManager(int size, const CkGroupID &gid);
 */
    static int __idx_CkCacheManager_marshall1;
    static int ckNew(int size, const CkGroupID &gid) { return __idx_CkCacheManager_marshall1; }
    static void _call_CkCacheManager_marshall1(void* impl_msg,CkCacheManager* impl_obj);
    static int _callmarshall_CkCacheManager_marshall1(char* impl_buf,CkCacheManager* impl_obj);
    static void _marshallmessagepup_CkCacheManager_marshall1(PUP::er &p,void *msg);

/* DECLS: CkCacheManager(int size, int n, const CkGroupID *gid);
 */
    static int __idx_CkCacheManager_marshall2;
    static int ckNew(int size, int n, const CkGroupID *gid) { return __idx_CkCacheManager_marshall2; }
    static void _call_CkCacheManager_marshall2(void* impl_msg,CkCacheManager* impl_obj);
    static int _callmarshall_CkCacheManager_marshall2(char* impl_buf,CkCacheManager* impl_obj);
    static void _marshallmessagepup_CkCacheManager_marshall2(PUP::er &p,void *msg);

/* DECLS: CkCacheManager(int size, int n, const CkGroupID *gid, int nWB, const CkGroupID *gidWB);
 */
    static int __idx_CkCacheManager_marshall3;
    static int ckNew(int size, int n, const CkGroupID *gid, int nWB, const CkGroupID *gidWB) { return __idx_CkCacheManager_marshall3; }
    static void _call_CkCacheManager_marshall3(void* impl_msg,CkCacheManager* impl_obj);
    static int _callmarshall_CkCacheManager_marshall3(char* impl_buf,CkCacheManager* impl_obj);
    static void _marshallmessagepup_CkCacheManager_marshall3(PUP::er &p,void *msg);

/* DECLS: void* requestData(const CkCacheKey &what, const CkArrayIndexMax &toWhom, int chunk, CkCacheEntryType* impl_msg, const CkCacheRequestorData &req);
 */
    static int __idx_requestData_marshall4;
    static int requestData(const CkCacheKey &what, const CkArrayIndexMax &toWhom, int chunk, CkCacheEntryType* impl_msg, const CkCacheRequestorData &req) { return __idx_requestData_marshall4; }
    static void _call_requestData_marshall4(void* impl_msg,CkCacheManager* impl_obj);
    static int _callmarshall_requestData_marshall4(char* impl_buf,CkCacheManager* impl_obj);
    static void _marshallmessagepup_requestData_marshall4(PUP::er &p,void *msg);

/* DECLS: void* requestDataNoFetch(const CkCacheKey &key, int chunk);
 */
    static int __idx_requestDataNoFetch_marshall5;
    static int requestDataNoFetch(const CkCacheKey &key, int chunk) { return __idx_requestDataNoFetch_marshall5; }
    static void _call_requestDataNoFetch_marshall5(void* impl_msg,CkCacheManager* impl_obj);
    static int _callmarshall_requestDataNoFetch_marshall5(char* impl_buf,CkCacheManager* impl_obj);
    static void _marshallmessagepup_requestDataNoFetch_marshall5(PUP::er &p,void *msg);

/* DECLS: void cacheSync(const int &numChunks, const CkArrayIndexMax &chareIdx, const int &localIdx);
 */
    static int __idx_cacheSync_marshall6;
    static int cacheSync(const int &numChunks, const CkArrayIndexMax &chareIdx, const int &localIdx) { return __idx_cacheSync_marshall6; }
    static void _call_cacheSync_marshall6(void* impl_msg,CkCacheManager* impl_obj);
    static int _callmarshall_cacheSync_marshall6(char* impl_buf,CkCacheManager* impl_obj);
    static void _marshallmessagepup_cacheSync_marshall6(PUP::er &p,void *msg);

/* DECLS: void recvData(CkCacheFillMsg* impl_msg);
 */
    static int __idx_recvData_CkCacheFillMsg;
    static int recvData(CkCacheFillMsg* impl_msg) { return __idx_recvData_CkCacheFillMsg; }
    static void _call_recvData_CkCacheFillMsg(void* impl_msg,CkCacheManager* impl_obj);

/* DECLS: void recvData(const CkCacheKey &key, const CkArrayIndexMax &from, CkCacheEntryType* impl_msg, int chunk, void* data);
 */
    static int __idx_recvData_marshall8;
    static int recvData(const CkCacheKey &key, const CkArrayIndexMax &from, CkCacheEntryType* impl_msg, int chunk, void* data) { return __idx_recvData_marshall8; }
    static void _call_recvData_marshall8(void* impl_msg,CkCacheManager* impl_obj);
    static int _callmarshall_recvData_marshall8(char* impl_buf,CkCacheManager* impl_obj);
    static void _marshallmessagepup_recvData_marshall8(PUP::er &p,void *msg);

/* DECLS: void writebackChunk(int num);
 */
    static int __idx_writebackChunk_marshall9;
    static int writebackChunk(int num) { return __idx_writebackChunk_marshall9; }
    static void _call_writebackChunk_marshall9(void* impl_msg,CkCacheManager* impl_obj);
    static int _callmarshall_writebackChunk_marshall9(char* impl_buf,CkCacheManager* impl_obj);
    static void _marshallmessagepup_writebackChunk_marshall9(PUP::er &p,void *msg);

/* DECLS: void finishedChunk(int num, const CmiUInt8 &weight);
 */
    static int __idx_finishedChunk_marshall10;
    static int finishedChunk(int num, const CmiUInt8 &weight) { return __idx_finishedChunk_marshall10; }
    static void _call_finishedChunk_marshall10(void* impl_msg,CkCacheManager* impl_obj);
    static int _callmarshall_finishedChunk_marshall10(char* impl_buf,CkCacheManager* impl_obj);
    static void _marshallmessagepup_finishedChunk_marshall10(PUP::er &p,void *msg);

/* DECLS: void collectStatistics(const CkCallback &cb);
 */
    static int __idx_collectStatistics_marshall11;
    static int collectStatistics(const CkCallback &cb) { return __idx_collectStatistics_marshall11; }
    static void _call_collectStatistics_marshall11(void* impl_msg,CkCacheManager* impl_obj);
    static int _callmarshall_collectStatistics_marshall11(char* impl_buf,CkCacheManager* impl_obj);
    static void _marshallmessagepup_collectStatistics_marshall11(PUP::er &p,void *msg);

/* DECLS: std::map<CkCacheKey,CkCacheEntry* >* getCache(void);
 */
    static int __idx_getCache_void;
    static int getCache(void) { return __idx_getCache_void; }
    static void _call_getCache_void(void* impl_msg,CkCacheManager* impl_obj);

/* DECLS: CkCacheEntry* requestCacheEntryNoFetch(const CkCacheKey &key, int chunk);
 */
    static int __idx_requestCacheEntryNoFetch_marshall13;
    static int requestCacheEntryNoFetch(const CkCacheKey &key, int chunk) { return __idx_requestCacheEntryNoFetch_marshall13; }
    static void _call_requestCacheEntryNoFetch_marshall13(void* impl_msg,CkCacheManager* impl_obj);
    static int _callmarshall_requestCacheEntryNoFetch_marshall13(char* impl_buf,CkCacheManager* impl_obj);
    static void _marshallmessagepup_requestCacheEntryNoFetch_marshall13(PUP::er &p,void *msg);

};
/* --------------- element proxy ------------------ */
class CProxyElement_CkCacheManager: public CProxyElement_IrrGroup{
  public:
    typedef CkCacheManager local_t;
    typedef CkIndex_CkCacheManager index_t;
    typedef CProxy_CkCacheManager proxy_t;
    typedef CProxyElement_CkCacheManager element_t;
    typedef CProxySection_CkCacheManager section_t;

    CProxyElement_CkCacheManager(void) {}
    CProxyElement_CkCacheManager(const IrrGroup *g) : CProxyElement_IrrGroup(g){  }
    CProxyElement_CkCacheManager(CkGroupID _gid,int _onPE,CK_DELCTOR_PARAM) : CProxyElement_IrrGroup(_gid,_onPE,CK_DELCTOR_ARGS){  }
    CProxyElement_CkCacheManager(CkGroupID _gid,int _onPE) : CProxyElement_IrrGroup(_gid,_onPE){  }
   CK_DISAMBIG_GROUP_ELEMENT(CProxyElement_IrrGroup)
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxyElement_IrrGroup::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxyElement_IrrGroup::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxyElement_IrrGroup::pup(p);
    }
    void ckSetGroupID(CkGroupID g) {
      CProxyElement_IrrGroup::ckSetGroupID(g);
    }
    CkCacheManager* ckLocalBranch(void) const {
      return ckLocalBranch(ckGetGroupID());
    }
    static CkCacheManager* ckLocalBranch(CkGroupID gID) {
      return (CkCacheManager*)CkLocalBranch(gID);
    }
/* DECLS: CkCacheManager(CkMigrateMessage* impl_msg);
 */

/* DECLS: CkCacheManager(int size, const CkGroupID &gid);
 */

/* DECLS: CkCacheManager(int size, int n, const CkGroupID *gid);
 */

/* DECLS: CkCacheManager(int size, int n, const CkGroupID *gid, int nWB, const CkGroupID *gidWB);
 */

/* DECLS: void* requestData(const CkCacheKey &what, const CkArrayIndexMax &toWhom, int chunk, CkCacheEntryType* impl_msg, const CkCacheRequestorData &req);
 */
    void* requestData(CkCacheKey &what, CkArrayIndexMax &toWhom, int chunk, CkCacheEntryType* impl_msg, CkCacheRequestorData &req, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void* requestDataNoFetch(const CkCacheKey &key, int chunk);
 */
    void* requestDataNoFetch(CkCacheKey &key, int chunk, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void cacheSync(const int &numChunks, const CkArrayIndexMax &chareIdx, const int &localIdx);
 */
    void cacheSync(int &numChunks, CkArrayIndexMax &chareIdx, int &localIdx, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void recvData(CkCacheFillMsg* impl_msg);
 */
    void recvData(CkCacheFillMsg* impl_msg);

/* DECLS: void recvData(const CkCacheKey &key, const CkArrayIndexMax &from, CkCacheEntryType* impl_msg, int chunk, void* data);
 */
    void recvData(CkCacheKey &key, CkArrayIndexMax &from, CkCacheEntryType* impl_msg, int chunk, void* data, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void writebackChunk(int num);
 */
    void writebackChunk(int num, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void finishedChunk(int num, const CmiUInt8 &weight);
 */
    void finishedChunk(int num, const CmiUInt8 &weight, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void collectStatistics(const CkCallback &cb);
 */
    void collectStatistics(const CkCallback &cb, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: std::map<CkCacheKey,CkCacheEntry* >* getCache(void);
 */
    std::map<CkCacheKey,CkCacheEntry* >* getCache(void);

/* DECLS: CkCacheEntry* requestCacheEntryNoFetch(const CkCacheKey &key, int chunk);
 */
    CkCacheEntry* requestCacheEntryNoFetch(CkCacheKey &key, int chunk, const CkEntryOptions *impl_e_opts=NULL);

};
PUPmarshall(CProxyElement_CkCacheManager)
/* ---------------- collective proxy -------------- */
class CProxy_CkCacheManager: public CProxy_IrrGroup{
  public:
    typedef CkCacheManager local_t;
    typedef CkIndex_CkCacheManager index_t;
    typedef CProxy_CkCacheManager proxy_t;
    typedef CProxyElement_CkCacheManager element_t;
    typedef CProxySection_CkCacheManager section_t;

    CProxy_CkCacheManager(void) {}
    CProxy_CkCacheManager(const IrrGroup *g) : CProxy_IrrGroup(g){  }
    CProxy_CkCacheManager(CkGroupID _gid,CK_DELCTOR_PARAM) : CProxy_IrrGroup(_gid,CK_DELCTOR_ARGS){  }
    CProxy_CkCacheManager(CkGroupID _gid) : CProxy_IrrGroup(_gid){  }
    CProxyElement_CkCacheManager operator[](int onPE) const
      {return CProxyElement_CkCacheManager(ckGetGroupID(),onPE,CK_DELCTOR_CALL);}
   CK_DISAMBIG_GROUP(CProxy_IrrGroup)
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxy_IrrGroup::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxy_IrrGroup::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxy_IrrGroup::pup(p);
    }
    void ckSetGroupID(CkGroupID g) {
      CProxy_IrrGroup::ckSetGroupID(g);
    }
    CkCacheManager* ckLocalBranch(void) const {
      return ckLocalBranch(ckGetGroupID());
    }
    static CkCacheManager* ckLocalBranch(CkGroupID gID) {
      return (CkCacheManager*)CkLocalBranch(gID);
    }
/* DECLS: CkCacheManager(CkMigrateMessage* impl_msg);
 */

/* DECLS: CkCacheManager(int size, const CkGroupID &gid);
 */
    static CkGroupID ckNew(int size, const CkGroupID &gid, const CkEntryOptions *impl_e_opts=NULL);
    CProxy_CkCacheManager(int size, const CkGroupID &gid, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: CkCacheManager(int size, int n, const CkGroupID *gid);
 */
    static CkGroupID ckNew(int size, int n, const CkGroupID *gid, const CkEntryOptions *impl_e_opts=NULL);
    CProxy_CkCacheManager(int size, int n, const CkGroupID *gid, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: CkCacheManager(int size, int n, const CkGroupID *gid, int nWB, const CkGroupID *gidWB);
 */
    static CkGroupID ckNew(int size, int n, const CkGroupID *gid, int nWB, const CkGroupID *gidWB, const CkEntryOptions *impl_e_opts=NULL);
    CProxy_CkCacheManager(int size, int n, const CkGroupID *gid, int nWB, const CkGroupID *gidWB, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void* requestData(const CkCacheKey &what, const CkArrayIndexMax &toWhom, int chunk, CkCacheEntryType* impl_msg, const CkCacheRequestorData &req);
 */

/* DECLS: void* requestDataNoFetch(const CkCacheKey &key, int chunk);
 */

/* DECLS: void cacheSync(const int &numChunks, const CkArrayIndexMax &chareIdx, const int &localIdx);
 */

/* DECLS: void recvData(CkCacheFillMsg* impl_msg);
 */
    void recvData(CkCacheFillMsg* impl_msg);
    void recvData(CkCacheFillMsg* impl_msg, int npes, int *pes);
    void recvData(CkCacheFillMsg* impl_msg, CmiGroup &grp);

/* DECLS: void recvData(const CkCacheKey &key, const CkArrayIndexMax &from, CkCacheEntryType* impl_msg, int chunk, void* data);
 */

/* DECLS: void writebackChunk(int num);
 */
    void writebackChunk(int num, const CkEntryOptions *impl_e_opts=NULL);
    void writebackChunk(int num, int npes, int *pes, const CkEntryOptions *impl_e_opts=NULL);
    void writebackChunk(int num, CmiGroup &grp, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void finishedChunk(int num, const CmiUInt8 &weight);
 */
    void finishedChunk(int num, const CmiUInt8 &weight, const CkEntryOptions *impl_e_opts=NULL);
    void finishedChunk(int num, const CmiUInt8 &weight, int npes, int *pes, const CkEntryOptions *impl_e_opts=NULL);
    void finishedChunk(int num, const CmiUInt8 &weight, CmiGroup &grp, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void collectStatistics(const CkCallback &cb);
 */
    void collectStatistics(const CkCallback &cb, const CkEntryOptions *impl_e_opts=NULL);
    void collectStatistics(const CkCallback &cb, int npes, int *pes, const CkEntryOptions *impl_e_opts=NULL);
    void collectStatistics(const CkCallback &cb, CmiGroup &grp, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: std::map<CkCacheKey,CkCacheEntry* >* getCache(void);
 */

/* DECLS: CkCacheEntry* requestCacheEntryNoFetch(const CkCacheKey &key, int chunk);
 */

};
PUPmarshall(CProxy_CkCacheManager)
/* ---------------- section proxy -------------- */
class CProxySection_CkCacheManager: public CProxySection_IrrGroup{
  public:
    typedef CkCacheManager local_t;
    typedef CkIndex_CkCacheManager index_t;
    typedef CProxy_CkCacheManager proxy_t;
    typedef CProxyElement_CkCacheManager element_t;
    typedef CProxySection_CkCacheManager section_t;

    CProxySection_CkCacheManager(void) {}
    CProxySection_CkCacheManager(const IrrGroup *g) : CProxySection_IrrGroup(g){  }
    CProxySection_CkCacheManager(const CkGroupID &_gid,const int *_pelist,int _npes,CK_DELCTOR_PARAM) : CProxySection_IrrGroup(_gid,_pelist,_npes,CK_DELCTOR_ARGS){  }
    CProxySection_CkCacheManager(const CkGroupID &_gid,const int *_pelist,int _npes) : CProxySection_IrrGroup(_gid,_pelist,_npes){  }
    CProxySection_CkCacheManager(int n,const CkGroupID *_gid, int const * const *_pelist,const int *_npes) : CProxySection_IrrGroup(n,_gid,_pelist,_npes){  }
    CProxySection_CkCacheManager(int n,const CkGroupID *_gid, int const * const *_pelist,const int *_npes,CK_DELCTOR_PARAM) : CProxySection_IrrGroup(n,_gid,_pelist,_npes,CK_DELCTOR_ARGS){  }
   CK_DISAMBIG_GROUP_SECTION(CProxySection_IrrGroup)
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxySection_IrrGroup::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxySection_IrrGroup::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxySection_IrrGroup::pup(p);
    }
    void ckSetGroupID(CkGroupID g) {
      CProxySection_IrrGroup::ckSetGroupID(g);
    }
    CkCacheManager* ckLocalBranch(void) const {
      return ckLocalBranch(ckGetGroupID());
    }
    static CkCacheManager* ckLocalBranch(CkGroupID gID) {
      return (CkCacheManager*)CkLocalBranch(gID);
    }
/* DECLS: CkCacheManager(CkMigrateMessage* impl_msg);
 */

/* DECLS: CkCacheManager(int size, const CkGroupID &gid);
 */

/* DECLS: CkCacheManager(int size, int n, const CkGroupID *gid);
 */

/* DECLS: CkCacheManager(int size, int n, const CkGroupID *gid, int nWB, const CkGroupID *gidWB);
 */

/* DECLS: void* requestData(const CkCacheKey &what, const CkArrayIndexMax &toWhom, int chunk, CkCacheEntryType* impl_msg, const CkCacheRequestorData &req);
 */

/* DECLS: void* requestDataNoFetch(const CkCacheKey &key, int chunk);
 */

/* DECLS: void cacheSync(const int &numChunks, const CkArrayIndexMax &chareIdx, const int &localIdx);
 */

/* DECLS: void recvData(CkCacheFillMsg* impl_msg);
 */
    void recvData(CkCacheFillMsg* impl_msg);

/* DECLS: void recvData(const CkCacheKey &key, const CkArrayIndexMax &from, CkCacheEntryType* impl_msg, int chunk, void* data);
 */

/* DECLS: void writebackChunk(int num);
 */
    void writebackChunk(int num, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void finishedChunk(int num, const CmiUInt8 &weight);
 */
    void finishedChunk(int num, const CmiUInt8 &weight, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: void collectStatistics(const CkCallback &cb);
 */
    void collectStatistics(const CkCallback &cb, const CkEntryOptions *impl_e_opts=NULL);

/* DECLS: std::map<CkCacheKey,CkCacheEntry* >* getCache(void);
 */

/* DECLS: CkCacheEntry* requestCacheEntryNoFetch(const CkCacheKey &key, int chunk);
 */

};
PUPmarshall(CProxySection_CkCacheManager)
typedef CBaseT<Group,CProxy_CkCacheManager>  CBase_CkCacheManager;

extern void _registerCkCache(void);
#endif
